;;
;; mailman.scm
;;
;; Mailman management interface
;;
;; ISC License
;;
;; Copyright 2023 Brmlab, z.s.
;; Dominik Pantůček <dominik.pantucek@trustica.cz>
;;
;; Permission to use, copy, modify, and/or distribute this software
;; for any purpose with or without fee is hereby granted, provided
;; that the above copyright notice and this permission notice appear
;; in all copies.
;; 
;; THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL
;; WARRANTIES WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED
;; WARRANTIES OF MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE
;; AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT, INDIRECT, OR
;; CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS
;; OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,
;; NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN
;; CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
;;

(declare (unit mailman))

(module
 mailman
 (
  *mailman-bin*
  list-mailman-lists
  )

 (import scheme
	 (chicken base)
	 (chicken pathname)
	 utils)

 ;; Where does the mailman binaries reside
 (define *mailman-bin* (make-parameter "/usr/lib/mailman/bin"))

 ;; Returns full path to given mailman binary
 (define (mailman-bin bin)
   (make-pathname (*mailman-bin*) bin))

 ;; Mailman-specific process output lines capture
 (define (get-mailman-output-lines bin)
   (get-process-output-lines
    (mailman-bin bin)))

 ;; Returns the list of available lists
 (define (list-mailman-lists)
   (get-mailman-output-lines "list_lists"))

 )
